class UE13Aufgabe1 {

	// Testprogramm fuer die Klasse Menge.
	public static void main(String[] argv) {
		Menge menge = new Menge(100);
		for (int i = 0; i < 10; i++) {
			System.out.println(i + " " + menge.addElement(i));
		}
		for (int i = 5; i < 15; i++) {
			System.out.println(i + " " + menge.addElement(i));
		}
	}
}

// Die Klasse Menge erbt von der Klasse Container.
class Menge extends Container {

	// Der Konstruktor wird explizit aufgerufen ...
	Menge(int size) {
		super(size);
	}

	// ... und Elemente werden nur dann hinzugefuegt, wenn sie nicht bereits
	// vorhanden sind.
	boolean addElement(int value) {
		if (this.existsElement(value)) {
			return false;
		} else {
			return super.addElement(value);
		}
	}
}

class Container {
	int next;
	int[] elems;

	// initialisiert ein Container-Objekt, das max. size Werte 
	// speichern kann
	Container(int size) {
		this.elems = new int[size];
		this.next = 0;
	}

	// voll?
	boolean isFull() {
		return this.next == this.elems.length;
	}

	// speichert value ab, auch wenn der Wert bereits gespeichert ist;
	// liefert true, wenn der Wert abgespeichert wurde
	boolean addElement(int value) {
		if (this.isFull()) {
			return false;
		}
		this.elems[this.next++] = value;
		return true;
	}

	// entfernt alle Vorkommen von value aus dem Speicher
	// liefert false, wenn der Wert nicht vorhanden war
	boolean removeElement(int value) {
		boolean result = false;
		int i = 0;
		while (i < this.next) {
			if (this.elems[i] == value) {
				result = true;
				for (int j = i; j < this.next - 1; j++) {
					this.elems[j] = this.elems[j + 1];
				}
				this.next--;
			} else {
				i++;
			}
		}
		return result;
	}

	// ueberprueft, ob value bereits gespeichert ist
	boolean existsElement(int value) {
		for (int i = 0; i < this.next; i++) {
			if (this.elems[i] == value) {
				return true;
			}
		}
		return false;
	}
}

