class DElement {
	int value; // Speicher fuer einen Wert
	DElement next; // Referenz auf das folgende Element (oder null fuer Ende)
	DElement prev; // Referenz auf das vorhergehende Element (oder null fuer
					// Anfang)

	DElement(int v, DElement n, DElement p) {
		this.value = v;
		this.next = n;
		this.prev = p;
	}
}

class DList {
	DElement first; // erstes Element der Liste
	DElement last; // letztes Element der Liste

	DList() {
		this.first = null;
		this.last = null;
	}

	void append(int i) {
		DElement elem = new DElement(i, null, this.last);
		if (this.first == null) { // erstes Element in der Liste
			this.first = elem;
			this.last = elem;
		} else { // Anhaengen des Elementes am Ende
			this.last.next = elem;
			this.last = elem;
		}
	}

	void print() {
		DElement elem = this.first;
		while (elem != null) {
			System.out.print(elem.value);
			if (elem.next != null) {
				System.out.print(" -> ");
			}
			elem = elem.next;
		}
		System.out.println();
	}
}

class RDList extends DList {
	RDList() {
		super();
	}

	void reverseDuplicate() {
		DElement elem = this.last;
		while (elem != null) {
			this.append(elem.value);
			elem = elem.prev;
		}
	}
}

public class UE13Aufgabe16 {

	public static void main(String[] args) {
		RDList list = new RDList();
		list.append(5);
		list.append(4);
		list.append(3);
		list.append(4);
		list.append(2);
		list.append(1);
		list.print();
		list.reverseDuplicate();
		list.print();
	}

}
